Opens an existing large object stream

- « Pdo\Pgsql::lobCreate

- Pdo\Pgsql::lobUnlink »

- PHP Manual
- Pdo\pgsql
- Opens an existing large object stream

# Pdo\Pgsql::lobOpen

(PHP 8 >= 8.4.0)

Pdo\Pgsql::lobOpen — Opens an existing large object stream

### Description

public Pdo\Pgsql::lobOpen(string `$oid`, string `$mode` = "rb"): resource|false

Pdo\Pgsql::lobOpen() opens a stream to access the data referenced by `oid`. All usual filesystem functions, such as fread(), fwrite() or fgets() can be used to manipulate the contents of the stream.

> Note: This function, and all manipulations of the large object, must be called and carried out within a transaction.

### Parameters

`oid`
  A large object identifier.
`mode`
  If mode is `r`, open the stream for reading. If mode is `w`, open the stream for writing.

### Return Values

Returns a stream resource on success, or `false` on failure.

### Errors/Exceptions

When does this function issue `E_*` level errors, and/or throw Exceptions.

### Examples

Example #1 Pdo\Pgsql::lobOpen() example

Following on from the Pdo\Pgsql::lobCreate() example, this code snippet retrieves the large object from the database and outputs it to the browser.

    <?php
    $db = new Pdo\Pgsql('pgsql:dbname=test host=localhost', $user, $pass);
    $db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
    $db->beginTransaction();
    $stmt = $db->prepare("SELECT oid FROM BLOBS WHERE ident = ?");
    $stmt->execute(array($some_id));
    $stmt->bindColumn('oid', $oid, PDO::PARAM_STR);
    $stmt->fetch(PDO::FETCH_BOUND);
    $stream = $db->pgsqlLOBOpen($oid, 'r');
    header("Content-type: application/octet-stream");
    fpassthru($stream);
    ?>

### See Also

- Pdo\Pgsql::lobCreate() - Creates a new large object
- Pdo\Pgsql::lobUnlink() - Deletes the large object
- pg_lo_create() - Create a large object
- pg_lo_open() - Open a large object